/* ########################################################################

			     indirection.c

   File: indirection.c
   Path: /home/fournigault/c/X11/xcoral-2.33/Smac/indirection.c
   Description: 
   Created: Tue Feb 21 12:55:59 MET 1995
   Author: Bruno Pages
   Modified: Tue Feb 21 12:56:00 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */



#if HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif

#include "indirection.h"
#include "list.h"
#include "operator.h"
#include "Const_.h"
#include "error.h"

#include "decl.h" /**/

/*   ((cast) *place) opername value; */

Instruction * indirection_assignment(place, lvalue, opername, cast, del)
     List * place;
     List * lvalue;
     char * opername;
     Type * cast;
     int del;
{
  if (del) {
    DELETE((List *) place->info);
    DELETE(lvalue);
    free(place);
    free(opername);
    return 0;
  }
  else {
    Instruction * p = MAKE((List *) place->info);
    FCT( Object,(*convert),(Object) );
    Instruction * value;
    Type * ptype;
    Type * type;
    
    if (p == ERROR) {
      DELETE(lvalue);
      free(place);
      free(opername);
      return ERROR;
    }
    
    value = MAKE(lvalue);
    
    if (value == ERROR) {
      free(place);
      free(opername);
      return ERROR;
    }
    
    ptype = GetExprType(p);
    type = GetExprType(value);
    
    free(place);
    
    if (! Type__IsaPointer(ptype)) {
      free(opername);
      Error("illegal indirection (not a pointer)", 1);
      Delete(p);
      Delete(value);
      return ERROR;
    }
    
    if (! cast) cast = Type__Pointed_Type(ptype);
    
    if (Type__IsaArray(cast)) {
      free(opername);
      Error("illegal assignment (*&array = ...)", 1);
      Delete(p);
      Delete(value);
      return ERROR;
    }
    
    if (*opername != '=') {
      Type * valtype;
      FCT( Object,(*bfct),(Object, Object, int));
      
      opername[strlen(opername) - 1] = 0;			/* enleve = */
      bfct = find_modifbinary_oper(opername, cast, type, &valtype);
      free(opername);

      if (bfct == 0) {
	Delete(p);
	Delete(value);
	return ERROR;
      }
      
      if ((convert = Type__Convertible(valtype, cast)) == 0) {
	error_incompatible_types(cast, valtype, 
				 "incompatible type in assignment");
	Delete(p);
	Delete(value);
	return ERROR;
      }
      
      return (Instruction *)
	IndirectionModify__IndirectionModify(p, value, bfct, cast, convert);
    }
    
    if ((convert = ExprType__Convertible(value, cast)) == 0) {
      free(opername);
      error_incompatible_types(cast, GetExprType(value), 
			       "incompatible type in assignment");
      Delete(p);
      Delete(value);
      return ERROR;
    }
    
    free(opername);
    
    return (Instruction *)
      IndirectionAssignment__IndirectionAssignment(p, value, cast, convert);
  }
}


/*   ((cast) *place)++/--; */

Instruction * indirection_post_incrdecr(place, value, cast, del)
     List * place;
     int    value;
     Type * cast;
     int del;
{
  if (del) {
    DELETE((List *) place->info);
    free(place);
    return 0;
  }
  else {
    Instruction * p = MAKE((List *) place->info);
    
    if (p == ERROR) {
      free(place);
      return ERROR;
    }
    else {
      Type * ptype = GetExprType(p);
      Type * type = Type__Pointed_Type(ptype);
      FCT( Object,(*convert),(Object) );
      FCT( Object,(*bfct),(Object, Object, int));
      
      free(place);
      
      if (! Type__IsaPointer(ptype)) {
	Delete(p);
	Error("illegal indirection (not a pointer)", 1);
	return ERROR;
      }
      
      if (! cast) cast = type;
      
      if (Type__IsaArray(cast)) {
	Delete(p);
	Error("illegal assignment (*(&array)++/--)", 1);
	return ERROR;
      }
      
      {
	Type * dummy;
	
	bfct = find_modifbinary_oper("+", cast, Type_Int, &dummy);
	
	if (bfct == 0) {
	  Delete(p);
	  return ERROR;
	}
      }
      
      if ((convert = Type__Convertible(type, cast)) == 0) {
	Delete(p);
	error_incompatible_types(cast, type, "incompatible type in assignment");
	return ERROR;
      }
      
      return (Instruction *)
	IndirectionPostIncrDecr__IndirectionPostIncrDecr
	  (p, value, bfct, cast, convert);
    }
  }
}
