/* ########################################################################

				while.c

   File: while.c
   Path: /home/fournigault/c/X11/xcoral-2.33/Smac/while.c
   Description: 
   Created: Tue Feb 21 13:02:55 MET 1995
   Author: Bruno Pages
   Modified: Tue Feb 21 13:02:55 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */



#include "While_.h"
#include "list.h"
#include "control.h"
#include "comma.h"

#include "decl.h" /**/

/*
  fct = make_while
  info = [test, body]
*/

Instruction * make_while(l, del)
    List * l;
    int del;
{
  List ** m = (List **) l->info;
  Instruction * result;

  if (del) {
    DELETE(m[0]);
    DELETE(m[1]);
    result = (Instruction *) 0;
  }
  else {
    Instruction * test;
    int terminal = Is_Terminal;
    
    Is_Terminal = 0;
    
    test = MAKE(m[0]);
    
    if (test == ERROR) {
      DELETE(m[1]);
      result = ERROR;
    }
    else {
      int prev_in_iter = in_iteration;
      int prev_in_switch = in_switch;
      Instruction * body;
      
      in_iteration = 1;
      in_switch = 0;
      
      if (m[1]->fct == no_comma_expression) {
	DELETE(m[1]);
	body = 0;
      }
      else
	body = MAKE(m[1]);
      
      if (body == ERROR) {
	Delete(test);
	result = ERROR;
      }
      else
	result = (Instruction *) While__While(test, body, in_iteration != 1);
      
      in_iteration = prev_in_iter;
      in_switch = prev_in_switch;
    }
    
    Is_Terminal = terminal;
  }
  
  free(l);
  free(m);
  
  return result;
}

/*
  fct = make_while
  info = [body, test]
*/

Instruction * make_do_while(l, del)
    List * l;
    int del;
{
  List ** m = (List **) l->info;
  Instruction * result;
  
  if (del) {
    if (m[0]) DELETE(m[0]);
    DELETE(m[1]);
    result = (Instruction *) 0;
  }
  else {
    Instruction * test;
    int terminal = Is_Terminal;
    int prev_in_iter = in_iteration;
    int prev_in_switch = in_switch;
    
    Is_Terminal = 0;
    
    test = MAKE(m[1]);
    
    if (test == ERROR) {
      DELETE(m[0]);
      result = ERROR;
    }
    else {
      Instruction * body;
      
      in_iteration = 1;
      in_switch = 0;
      
      body = (m[0]) ? MAKE(m[0]) : 0;
      
      if (body == ERROR) {
	Delete(test);
	result = ERROR;
      }
      else
	result = (Instruction *)
	  DoWhile__DoWhile(test, body, in_iteration != 1);
      
      in_iteration = prev_in_iter;
      in_switch = prev_in_switch;
    }

    Is_Terminal = terminal;
  }
  
  free(l);
  free(m);
  
  return result;
}

